#ifndef __SYLPHACTIONS_H
#define __SYLPHACTIONS_H

#include <vector>

enum SylphFrameType {sfDisplayConstant, sfDisplayProgress, sfProcessConstant, sfProcessProgress, sfAuto};

class SylphFrame;

class SylphAction {
	public:
		virtual void Step(SylphFrame& frame) = 0;
		virtual ~SylphAction();
		virtual SylphFrameType DefaultType();
};

typedef std::vector<SylphAction*> SylphActions;

class SylphFrame {
	protected:
		SylphActions constant[2];
		SylphActions progress[2];
		int FLastScanLines;
		int FFrameCount;
	public:
		SylphFrame();
		void FrameStep(bool doprogress);
		void Register(SylphAction& action, SylphFrameType type=sfAuto);
		void Unregister(SylphAction& action, SylphFrameType type=sfAuto);
		
		inline int FrameCount() { return FFrameCount; }
		inline int LastScanLines() { return FLastScanLines; }
};

#endif
