/*
     ``The contents of this file are subject to the Mozilla Public License
     Version 1.1 (the "License"); you may not use this file except in
     compliance with the License. You may obtain a copy of the License at
     http://www.mozilla.org/MPL/

     Software distributed under the License is distributed on an "AS IS"
     basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
     License for the specific language governing rights and limitations
     under the License.

     The Original Code is SylphDS (www.sylphds.net).

     The Initial Developer of the Original Code is Ficedula (web@sylphds.net).
*/

#include "nds.h"
#include "SylphData.h"

SylphFile::~SylphFile() {
}
		
int SylphFile::Seek(int offset, SylphSeek Where) {
	switch (Where) {
		case soStart:	Position = offset; break;
		case soCurrent:	Position += offset; break;
		case soEnd:		Position = FileSize+offset; break;
	}
	if (Position < 0) Position = 0;
	if (Position > FileSize) Position = FileSize;
	return Position;
}

SylphFile* SylphFileInfo::File() {
	return Filer().GetData(Filename);
}


SylphDataPlugin::~SylphDataPlugin() {
}

SylphFiler::SylphFiler() {
	printf("SylphFiler: Initialise\n");
}

SylphFiler::~SylphFiler() {
	u32 i;
	for (i=0; i < plugins.size(); i++)
		delete plugins[i];
}

SylphFile* SylphFiler::GetData(std::string filename) {
	SylphFile* result=NULL;
	u32 i;
	for (i=0; i < plugins.size(); i++)
		if (plugins[i]->GetData(filename, &result)) return result;
	return result;
}

SylphFiles SylphFiler::EnumFiles(std::string path) {
	SylphFiles* inter = NULL;
	u32 i;
	for (i=0; i < plugins.size(); i++) {
		inter = plugins[i]->EnumFiles(path);
		if (inter && inter->size()) return *inter; else delete inter;
	}
	return *new SylphFiles;
}

void SylphFiler::RegisterPlugin(SylphDataPlugin& plugin) {
	plugins.push_back(&plugin);
	printf("SylphFiler; registering data source %s\n", plugin.PluginName().c_str());
}

SylphFiler& Filer() {
	static SylphFiler TheFiler;
	return TheFiler;
}
