/*
     ``The contents of this file are subject to the Mozilla Public License
     Version 1.1 (the "License"); you may not use this file except in
     compliance with the License. You may obtain a copy of the License at
     http://www.mozilla.org/MPL/

     Software distributed under the License is distributed on an "AS IS"
     basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
     License for the specific language governing rights and limitations
     under the License.

     The Original Code is SylphDS (www.sylphds.net).

     The Initial Developer of the Original Code is Ficedula (web@sylphds.net).
*/

#include "SylphDataCF.h"
#include "gba_nds_fat/gba_nds_fat.h"

int SylphCFDataPlugin::GetData(std::string filename, SylphFile** file) {
	if (!FActive) return 0;
	std::string cfilename = "/" + filename;
	FAT_FILE* ffile = FAT_fopen(cfilename.c_str(), "r");
	if (ffile == (FAT_FILE*)-1) return 0;
	SylphCFFile* cff = new SylphCFFile;
	cff->FFile = ffile;
	cff->FileSize = FAT_GetFileSize();
	cff->Flags = ATTR_VALID;
	cff->Position = 0;
	*file = cff;
	return 1;
}

SylphFiles* SylphCFDataPlugin::EnumFiles(std::string path) {
	return NULL;
}

SylphCFDataPlugin::~SylphCFDataPlugin() {
	FAT_FreeFiles();
}

SylphCFDataPlugin::SylphCFDataPlugin() {
	FActive = FAT_InitFiles();
	if (FActive) printf("SylphCF: Init data plugin\n");
}

std::string SylphCFDataPlugin::PluginName() {
	return "CF/FAT interface (Chism's driver)";
}

int SylphCFFile::Read(void* buffer, int count) {
	return FAT_fread(buffer, 1, count, FFile);
}

int SylphCFFile::Seek(int offset, SylphSeek Where) {
	int result = SylphFile::Seek(offset, Where);
	FAT_fseek(FFile, result, 0);
	return result;
}

SylphCFFile::~SylphCFFile() {
	FAT_fclose(FFile);
}
