/*
     ``The contents of this file are subject to the Mozilla Public License
     Version 1.1 (the "License"); you may not use this file except in
     compliance with the License. You may obtain a copy of the License at
     http://www.mozilla.org/MPL/

     Software distributed under the License is distributed on an "AS IS"
     basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
     License for the specific language governing rights and limitations
     under the License.

     The Original Code is SylphDS (www.sylphds.net).

     The Initial Developer of the Original Code is Ficedula (web@sylphds.net).
*/

#include <nds.h>
#include "SylphDataRaw.h"
#include "SylphData.h"
#include <string>

// # include "ff7ds_bombing_it.h"
// # include "ff7ds_battle_it.h"
// # include "ff7ds_demo_it.h"
// # include "ff7ds_victory_it.h"
// #include "aerisb_pds_bin.h"
#include "font_bin.h"
#include "memo_sly.h"
#include "keybL_sly.h"
#include "keybH_sly.h"
#include "sylphirc_cfg.h"
#include "border1_stex.h"

int SylphRawDataPlugin::GetData(std::string filename, SylphFile** file) {
	const u8* data=NULL;
	int datasize=0;
/*
	if (filename == "ff7ds_bombing.it") { data = ff7ds_bombing_it; datasize = ff7ds_bombing_it_size; }
	if (filename == "ff7ds_battle.it") { data = ff7ds_battle_it; datasize = ff7ds_battle_it_size; }
	if (filename == "ff7ds_demo.it") { data = ff7ds_demo_it; datasize = ff7ds_demo_it_size; }
	if (filename == "ff7ds_victory.it") { data = ff7ds_victory_it; datasize = ff7ds_victory_it_size; }
*/
//	if (filename == "aerisb_pds2.bin") { data = aerisb_pds_bin; datasize = aerisb_pds_bin_size; }
	if (filename == "sylphirc/font.bin") { data = font_bin; datasize = font_bin_size; }
	if (filename == "sylphirc/memo.sly") { data = memo_sly; datasize = memo_sly_size; }
	if (filename == "sylphirc/keybl.sly") { data = KeybL_sly; datasize = KeybL_sly_size; }
	if (filename == "sylphirc/keybh.sly") { data = KeybH_sly; datasize = KeybH_sly_size; }
	if (filename == "sylphirc/sylphirc.cfg") { data = sylphirc_cfg; datasize = sylphirc_cfg_size; }
	if (filename == "sylphirc/border1.stex") { data = border1_stex; datasize = border1_stex_size; }
	if (data) {
		SylphRawFile &rf = *(new SylphRawFile());
		rf.data = (u8*)data;
		rf.datasize = datasize;
		rf.Filename = filename;
		rf.FileSize = datasize;
		rf.Flags = 0;
		rf.Position = 0;
		*file = &rf;
		return 1;
	} else return 0;
}

SylphFiles* SylphRawDataPlugin::EnumFiles(std::string path) {
	return NULL;
/*	SylphFiles* result = new SylphFiles;
	SylphFileInfo* aeris = new SylphFileInfo;
	aeris->Filename = "aerisb_pds2.bin";
	aeris->FileSize = aerisb_pds_bin_size;
	aeris->Attributes = ATTR_VALID;
	result->push_back(aeris);
	return result; */
}

SylphRawDataPlugin::~SylphRawDataPlugin() {
}

std::string SylphRawDataPlugin::PluginName() {
	return "Raw/compiled data";
}

int SylphRawFile::Read(void* buffer, int count) {
	if ((Position + count) > datasize) count = datasize - Position;
	if (count <= 0) return 0;
	memcpy(buffer, &data[Position], count);
	Position += count;
	return count;
}

