#ifndef __SYLPHLAYOUT_H
#define __SYLPHLAYOUT_H

#include <map>
#include <string>

#include "SylphUtil.h"
#include "Sylph2D.h"
#include "SylphData.h"

typedef std::map<std::string, SylphWidget*> SylphNamedWidgets;

enum TouchType {ttNone, ttDown, ttHold, ttUp};

struct TouchResult {
	std::string name;
	TouchType type;
	SylphWidget* widget;
};

class SylphLayout {
	protected:
		StringList FData;
		SylphNamedWidgets FWidgets;
		SylphBackground& FBack;
		SylphFont& FFont;
		bool FOwns;
		TouchType FLastTouch;
		SylphWidget* FLastWidget;
		SylphWidget* FFocus;
	protected:
		void FClear();
		void FLoad();
	public:
		SylphLayout(SylphBackground& back, SylphFont& font, bool OwnWidgets=false);
		~SylphLayout();
	
		void Load(SylphFile& file);
		void Load(StringList sl);
		inline void Clear() { FClear(); }
		
		std::string getName(SylphWidget* w);
		SylphWidget* Widget(std::string name);
		TouchResult ProcessTouch();
		SylphWidget* findNextWidget(SylphWidget& from, int vert, int horiz, bool testFocus = true);
		inline SylphWidget* getFocus() { return FFocus; }
		inline void setFocus(SylphWidget* w) { if (FFocus && FFocus->getFocussed()) FFocus->setFocussed(false); FFocus = w; w->setFocussed(true); }
		inline void setFirstFocus() { if (FWidgets.size()) FFocus = FWidgets.begin()->second; }
};

#endif
