/*
     ``The contents of this file are subject to the Mozilla Public License
     Version 1.1 (the "License"); you may not use this file except in
     compliance with the License. You may obtain a copy of the License at
     http://www.mozilla.org/MPL/

     Software distributed under the License is distributed on an "AS IS"
     basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
     License for the specific language governing rights and limitations
     under the License.

     The Original Code is SylphDS (www.sylphds.net).

     The Initial Developer of the Original Code is Ficedula (web@sylphds.net).
*/

#include "SylphSound9.h"
#include "SylphIPC.h"

void SylphSound9::PlayBuffer(s16* buffer, int chanbufsize) {
	SIPC().Send(ipSoundBuffer, MakeSoundBuffer(sbcSize, chanbufsize));
	int offset = ((u32)buffer - 0x2000000) >> 2;
	SIPC().Send(ipSoundBuffer, MakeSoundBuffer(sbcOffset, offset));
}

void SylphSound9::SetBufferVolume(int left, int right) {
	SIPC().Send(ipSoundBuffer, MakeSoundBuffer(sbcVolume, left | (right << 8)));
}

void SylphSound9::StopBuffer() {
	SIPC().Send(ipSoundBuffer, MakeSoundBuffer(sbcStop, 0));
}

SylphSound9::SylphSound9() : FFillBuffer(0) {
}

SylphSound9& Sound9() {
	static SylphSound9 snd9;
	return snd9;
}
