#ifndef __SYLPH_UDP
#define __SYLPH_UDP

#include "dswifi9.h"
#include "sys\socket.h"
#include "netinet\in.h"

#include <string>

enum SylphUDPOpcode {suNOP = 0, suDebug, suFileStat, suFileScan, suFileRead,
	suPersist, suFileReset, suRePing, suPersistR};

class SylphUDP {
	private:
		void SendStringPacket(std::string& s, SylphUDPOpcode opcode);
	protected:
		int FServerIP;
		int FServerPort;
		int FSocket;
		u8 FRBuffer[1700];
	public:
		void Send(void* data, int datasize);
		
		void NOP();
		void Debug(std::string& text);
		void FileStat(std::string& filename);
		void FileScan(std::string& folder);
		void FileRead(int FileID, int requests, int* requestdata);
		void Persist(int PID, int offset, int datasize, void* data);
		void FileReset();
		void RePing(int data);
		void PersistR(int PID, int offset, int datasize);
		
		void Process();
		void Connect();
		
		inline int getServerIP() { return FServerIP; }
		inline void setServerIP(int IP) { FServerIP = IP; }
		
		inline int getServerPort() { return FServerPort; }
		inline void setServerPort(int port) { FServerPort = port; }
};

SylphUDP& SUDP();

#endif
