#ifndef __SYLPHUTIL_H
#define __SYLPHUTIL_H

#include <string>
#include <vector>
#include <map>
#include <nds.h>

#include "SylphData.h"

typedef std::vector<std::string> StringList;
typedef std::map<std::string, std::string> StringListVals;

std::string IntToStr(int val);
std::string IPToStr(u32 IP);
StringList LoadSL(SylphFile& file);
StringList LoadSL(const std::string& data);
StringListVals LoadSLV(StringList& src);
StringListVals LoadSLV(SylphFile& file);
StringList Tokenise(const std::string& data, const std::string& breaker, bool DoTrim=true);
std::string UnTokenise(const StringList& source, const std::string& breaker); //TODO: Quoting
std::string Trim(const std::string& s);
std::string Lowercase(const std::string& s);
template<class T> int IndexOf(std::vector<T> src, T data);
#endif
