/*
     ``The contents of this file are subject to the Mozilla Public License
     Version 1.1 (the "License"); you may not use this file except in
     compliance with the License. You may obtain a copy of the License at
     http://www.mozilla.org/MPL/

     Software distributed under the License is distributed on an "AS IS"
     basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
     License for the specific language governing rights and limitations
     under the License.

     The Original Code is SylphDS (www.sylphds.net).

     The Initial Developer of the Original Code is Ficedula (web@sylphds.net).
*/

#include "nds.h"
#include <nds/arm9/console.h> //basic print funcionality
#include <stdio.h>
#include <string>
#include <sstream>
#include <malloc.h>

#include "dswifi9.h"
#include "sys\socket.h"
#include "netinet\in.h"

#include "SylphData.h"
#include "SylphDataRaw.h"
#include "SylphActions.h"
#include "SylphActionsDef.h"
#include "SylphNet.h"
#include "SylphDataCF.h"
#include "SylphUtil.h"
#include "ScrIRC.h"
#include "SylphIRC.h"

const char * assocstatus_strings[] = {
	"ASSOCSTATUS_DISCONNECTED",		// not *trying* to connect
	"ASSOCSTATUS_SEARCHING",		// data given does not completely specify an AP, looking for AP that matches the data.
	"ASSOCSTATUS_AUTHENTICATING",	// connecting...
	"ASSOCSTATUS_ASSOCIATING",		// connecting...
	"ASSOCSTATUS_ACQUIRINGDHCP",	// connected to AP, but getting IP data from DHCP
	"ASSOCSTATUS_ASSOCIATED",		// Connected!
	"ASSOCSTATUS_CANNOTCONNECT",	// error in connecting...
};

//---------------------------------------------------------------------------------
int main(void) {
//---------------------------------------------------------------------------------
	int i,j;

	IPC->mailData=0;
	IPC->mailSize=0;

	DC_FlushAll();
	powerON(POWER_ALL);
	
	memset(OAM, 0, 1024);
	memset(OAM_SUB, 0, 1024);
	memset(BG_PALETTE, 0, 1024);
	memset(BG_PALETTE_SUB, 0, 1024);
	
	irqInit();
	irqEnable(IRQ_VBLANK);

	videoSetModeSub(MODE_0_2D | DISPLAY_BG0_ACTIVE);	//sub bg 0 will be used to print text
	vramSetBankC(VRAM_C_SUB_BG);

	SUB_BG0_CR = BG_MAP_BASE(31);
	BG_PALETTE_SUB[255] = RGB15(31,31,31);	//by default font will be rendered with color 255
	consoleInitDefault((u16*)SCREEN_BASE_BLOCK_SUB(31), (u16*)CHAR_BASE_BLOCK_SUB(0), 16);
	printf("SylphDS/SylphIRC %s\n", SYLPH_IRC_VERSION.c_str());
	for (i=0; i<30; i++) { swiWaitForVBlank(); } //wait

	Filer().RegisterPlugin(*(new SylphRawDataPlugin()));


	SylphNetInit();
	iprintf("Connecting to WFC AP...\n");
	Wifi_DisconnectAP();
	Wifi_AutoConnect();
	
	i = -1;
	while(true) {
		j = Wifi_AssocStatus();
		if (i != j) {
			printf(assocstatus_strings[j]); printf("\n");
			i=j;
			if (i==ASSOCSTATUS_CANNOTCONNECT) {
				printf("Error...");
				while(true) swiWaitForVBlank();
			} else if (i==ASSOCSTATUS_ASSOCIATED) break;
		}
	}
	printf("OK - initialising SylphDS\n");

	LaunchIRC();

	return 0;
}
