#ifndef __SYLPHIPC_H
#define __SYLPHIPC_H

#include "nds.h"

enum SylphIPCCmd {ipHeartbeat, ipEcho, ipSoundSystem, ipSoundBuffer, ipDebug, ipMikMod=255};

class SylphIPC {
	public:
		void Process(SylphIPCCmd command, int param);
		void Send(SylphIPCCmd command, int param);
		int RemoteStatus() { return REG_IPC_SYNC & 0xf; }
		int LocalStatus() { return (REG_IPC_SYNC >> 8) & 0xf; }
		void SetLocalStatus(int status) { REG_IPC_SYNC = (REG_IPC_SYNC & 0xf0ff) | (status << 8); }
};

SylphIPC& SIPC();
void SylphIPCInit();

#endif
